﻿;{
   ProgName.s=GetFilePart(ProgramFilename()) 
   a = CreateSemaphore_(#Null,0,1,@ProgName) 
   If a<>0 And GetLastError_()=#ERROR_ALREADY_EXISTS 
     CloseHandle_(a) 
     End 
   EndIf
;} 
   
Enumeration
  
  #Window
  
  #PathString
  #OpenButton
  #File
  
  #Text
  
  #Fr01
  #Fr02
  
  
  #Ch1R
  #Ch2R
  #Ch3R
  #Ch4R
  #Ch1L
  #Ch2L
  #Ch3L
  #Ch4L
  
  
  #Ch1R2
  #Ch2R2
  #Ch3R2
  #Ch4R2
  #Ch1L2
  #Ch2L2
  #Ch3L2
  #Ch4L2
  
EndEnumeration 

; SN76489 module v1.01 by Wilbert
; modeled after ActionScript code by Shiru

DeclareModule SN76489
  
  Declare SN76489()
  Declare Clock(freq.l)
  Declare Reset()
  Declare Render(*buf, len.l)
  Declare GGStereoWrite(val.u)
  Declare Write(val.u)
  
EndDeclareModule

Module SN76489
  
  EnableExplicit
  DisableDebugger  
  EnableASM
  
  ;- Structures
  
  Structure SN76489_State
    ticksCount.l      ; offset 0
    ticksPerSample.l  ; offset 4
    vol.a[8]          ; offset 8
    div.u[8]          ; offset 16
    cnt.w[8]          ; offset 32
    out.w[8]          ; offset 48
    noiseLFSR.u[2]    ; offset 64
    noiseTap.u[2]     ; offset 68
    channel_mix.l[8]  ; offset 72
    latchedChan.a[2]  ; offset 104
    latchedVol.a[2]   ; offset 106
    vt.w[32]          ; offset 108
    dualchip.a        ; offset 172
  EndStructure
  
  ;-Global variables
  
  Global SN76489_State.SN76489_State
  
  ;- Render core
  
  CompilerIf #PB_Compiler_Processor = #PB_Processor_x86
    Macro rax : eax : EndMacro
    Macro rbx : ebx : EndMacro
    Macro rdx : edx : EndMacro
    Macro rsi : esi : EndMacro
    Macro rdi : edi : EndMacro
  CompilerEndIf  
  
  Macro M_Channel(chip, channel)
    sub word [rsi+32 + chip*8 + channel*2], 1     ; cnt - 1
    !jnc .c1#chip#channel                         ; cnt < 0 => c1#channel
    movzx ecx, word [rsi+16 + chip*8 + channel*2] ; get div
    CompilerIf channel = 3
      !and ecx, 3
      !mov eax, 0x10
      !shl al, cl
      !jns .n0#chip
      movzx eax, word [rsi+20 + chip*8]           ; get divC
      !shl eax, 1                                 ; divC << 1
      !.n0#chip:
      mov ecx, eax                                ; ecx = cntD
      movzx eax, word [rsi+64 + chip*2]           ; get noiseLFSR 
      cmp word [rsi+68 + chip*2], 9               ; noiseTap 9 => .n1
      !jne .n1#chip
      !and eax, 9                                 ; tap & 9
      !xor al, ah                                 ; get parity
      !setnp al
      !.n1#chip:
      !and eax, 1
      !shl eax, 16
      add ax, [rsi+64 + chip*2]
      !shr eax, 1
      mov [rsi+64 + chip*2], ax                   ; update noiseLFSR
      !xor eax, 1
      !shl eax, 12
      mov al, [rsi+11 + chip*4]                   ; get volD
      !and al, 15
      !or al, ah
      !and eax, 31
    CompilerElse
      !cmp ecx, 1                                 ; div <= 1 => c0#channel
      !jna .c0#chip#channel
      movzx eax, byte [rsi+8 + chip*4 + channel]  ; get vol
      !xor eax, 16                                ; vol ! 16
    CompilerEndIf
    mov [rsi+8 + chip*4 + channel], al            ; set vol
    movzx eax, word [rsi+108 + rax*2]             ; lookup vol in table
    mov [rsi+48 + chip*8 + channel*2], ax         ; out = lookup value
    !.c0#chip#channel:
    mov [rsi+32 + chip*8 + channel*2], cx         ; set cnt
    !.c1#chip#channel:
  EndMacro
  
  Macro M_ChannelOut(chip, channel)
    movsx ecx, word [rsi+48 + chip*8 + channel*2]
    movzx edx, cx
    imul ecx, 0xff80                              ; slight voltage decay
    sar ecx, 16
    mov [rsi+48 + chip*8 + channel*2], cx
    imul edx, [rsi+72 + chip*16 + channel*4]      ; apply channel mix
    !add eax, edx
    !and eax, 0xfffefffe
  EndMacro
  
  Procedure Render(*buf, len.l)
    !mov ecx, [p.v_len]
    !test ecx, ecx
    !jz .exit
    mov rax, *buf
    mov rsi, SN76489_State
    push rbx
    push rsi
    push rdi
    mov rdi, rax
    mov ebx, ecx
    movzx edx, byte [rsi+172]    
    !.rloop:
    M_Channel(0,0)
    M_Channel(0,1)
    M_Channel(0,2)
    M_Channel(0,3)
    !test edx, edx
    !jz .rskip0 
    M_Channel(1,0)
    M_Channel(1,1)
    M_Channel(1,2)
    M_Channel(1,3)
    !.rskip0:
    sub dword [rsi], 0x01000000                   ; update ticksCount
    !ja .rloop
    mov eax, [rsi+4]                              ; ticksCount+=ticksPerSample
    add [rsi], eax
    !xor eax, eax
    M_ChannelOut(0,0)
    M_ChannelOut(0,1)
    M_ChannelOut(0,2)
    M_ChannelOut(0,3)
    movzx edx, byte [rsi+172] 
    !test edx, edx
    !jz .rskip1
    M_ChannelOut(1,0)
    M_ChannelOut(1,1)
    M_ChannelOut(1,2)
    M_ChannelOut(1,3)
    !.rskip1:
    mov [rdi], eax                                ; write samples
    add rdi, 4
    sub ebx ,1
    !jnz .rloop
    pop rdi
    pop rsi
    pop rbx
    !.exit:
  EndProcedure
  
  ;- Other procedures
  
  Procedure Clock(freq.l)
    mov rdx, SN76489_State
    !mov eax, [p.v_freq]
    !bt eax, 30
    !setc cl
    mov [rdx+172], cl
    !and eax, 0x003fffff
    !cdq
    !mov ecx, 0x01000000
    !mul ecx
    !mov ecx, 16 * 44100
    !div ecx
    mov rdx, SN76489_State
    mov [rdx+4], eax
  EndProcedure
  
  Procedure Reset()
    FillMemory(@SN76489_State\vol[0], 8, 15, #PB_Byte)
    FillMemory(@SN76489_State\div[0], 16, 1, #PB_Word)
    FillMemory(@SN76489_State\cnt[0], 76)
    FillMemory(@SN76489_State\channel_mix[0], 32, $00010001, #PB_Long)
    With SN76489_State
      \ticksCount = \ticksPerSample
      \noiseLFSR[0] = $8000 : \noiseLFSR[1] = $8000
    EndWith
  EndProcedure
  
  Procedure SN76489()
    Protected i.i
    With SN76489_State
      \vt[0] = 4095 : \vt[1] = 4095 : \vt[2] = 4095
      \vt[3] = 3489 : \vt[4] = 2860 : \vt[5] = 2282
      \vt[6] = 1855 : \vt[7] = 1483 : \vt[8] = 1180
      \vt[9] =  909 : \vt[10] = 730 : \vt[11] = 565
      \vt[12] = 441 : \vt[13] = 344 : \vt[14] = 275
      \vt[15] = 0
      For i = 0 To 15 : \vt[i + 16] = -0.33 * \vt[i] : Next
    EndWith
    ;Clock(3579545)
    Clock($40000000 | 3579545)
    Reset()
  EndProcedure
  
  Procedure Write(val.u); bit 8 = chip 0 / 1
    Protected.l chip, chan_offset, chan, cdiv
    chip = val >> 8 & 1 : chan_offset = chip << 2
    If val & $80
      chan = val >> 5 & 3
      cdiv = SN76489_State\div[chan + chan_offset] & $fff0 | (val & $f)
      SN76489_State\latchedChan[chip] = chan
      SN76489_State\latchedVol[chip] = val >> 4 & 1
    Else
      chan = SN76489_State\latchedChan[chip]
      cdiv = SN76489_State\div[chan + chan_offset] & $f | (val << 4 & $3f0)
    EndIf
    If SN76489_State\latchedVol[chip]
      SN76489_State\vol[chan + chan_offset] = SN76489_State\vol[chan + chan_offset] & $10 | (val & $f)
      If cdiv = 1
        SN76489_State\out[chan + chan_offset] = SN76489_State\vt[val & $f]
      EndIf  
    Else
      SN76489_State\div[chan + chan_offset] = cdiv
      If chan = 3
        SN76489_State\noiseTap[chip] = cdiv << 1 & 8 + 1
        SN76489_State\noiseLFSR[chip] = $8000      
      EndIf
    EndIf
  EndProcedure
  
  Procedure GGStereoWrite(val.u); bit 8 = chip 0 / 1
    Debug Bin(val)
    Protected.l i
    For i = 0 To 3
      SN76489_State\channel_mix[val >> 6 & 4 + i] = (val >> (i+4) & 1) | (val << (16-i) & $10000)
    Next
  EndProcedure
    
EndModule

UseModule SN76489
SN76489()

#PSG_BUFFERS = 4
Global Dim wavebuf.w(#PSG_BUFFERS - 1, 2047)
Global Dim wavehdr.WAVEHDR(#PSG_BUFFERS - 1)
Global.i PSG_Unit, WMME_Playing

DataSection
  PCM16BitSigned:
  Data.w 1,2,$AC44,0,$B110,2,4,16,0
EndDataSection  

Procedure WMME_Callback(hwo, uMsg, dwInstance, *wavehdr.WAVEHDR, dwParam2)
  If WMME_Playing And uMSG = #WOM_DONE
    Render(*wavehdr\lpData, 1024)
    waveOutWrite_(hwo, *wavehdr, SizeOf(WAVEHDR))
  EndIf
EndProcedure

Procedure PSG_Terminate()
  Protected i.i
  If PSG_Unit
    WMME_Playing = #False
    waveOutReset_(PSG_Unit)
    While i < #PSG_BUFFERS     
      waveOutUnprepareHeader_(PSG_Unit, @wavehdr(i), SizeOf(WAVEHDR))
      i + 1
    Wend        
    waveOutClose_(PSG_Unit)
    PSG_Unit = 0
  EndIf
EndProcedure  

Procedure PSG_Init()
  If waveOutOpen_(@PSG_Unit, #WAVE_MAPPER, ?PCM16BitSigned, @WMME_Callback(), 0, #CALLBACK_FUNCTION)
    MessageRequester("Error", "Unable to initialize PSG")
  Else
    While i < #PSG_BUFFERS
      wavehdr(i)\lpData = @wavebuf(i, 0)
      wavehdr(i)\dwBufferLength = 4096
      waveOutPrepareHeader_(PSG_Unit, @wavehdr(i), SizeOf(WAVEHDR))
      waveOutWrite_(PSG_Unit, @wavehdr(i), SizeOf(WAVEHDR))
      i + 1
    Wend
    WMME_Playing = #True   
  EndIf
EndProcedure

PSG_Init()

Structure VGMFSt
  type.i
  reg.a
  val.a
  pause.u
  samplenum.a
  sampleadress.i
  samplesize.i
  summofpauses.i
EndStructure
Global Dim VGMARR.VGMFSt(0)

Global TormozFlag = 1
Global PlThr

;{
Macro SetBit(Var, Bit)
  Var | (Bit)
EndMacro
 
Macro ClearBit(Var, Bit)
  Var & (~(Bit))
EndMacro

Macro TestBit(Var, Bit)
  Bool(Var & (Bit))
EndMacro
 
Macro NumToBit(Num)
  (1<<(Num))
EndMacro

Macro GetBits(Var, StartPos, EndPos)
  ((Var>>(StartPos))&(NumToBit((EndPos)-(StartPos)+1)-1))
EndMacro
;}

Procedure Play(*Value)
  
  PlayedTicks.i = 0
  PlayedUS.i = 0
  CurrentUS.i = 0
  StartMS.i = ElapsedMilliseconds()

  For i = start To ArraySize(VGMARR())-1

    Select VGMARR(i)\type
      Case 3 ; pauses    
        PlayedTicks + VGMARR(i)\pause
        PlayedUS = PlayedTicks * 22.675736961;90.702947844;22.675736961
        While (CurrentUS < PlayedUS)
          Delay(1)
          CurrentUS.i = (ElapsedMilliseconds() - StartMS) * 1000
        Wend

      Case 5 ; PSG
        Write(VGMARR(i)\val)
        
      ;Case 6 ; PSG
      ;  ;Write(VGMARR(i)\val) ;Write2?
      ;  ;Write(VGMARR(i)\val)
        
      Case 7 ; stereo flags
        GGStereoWrite(VGMARR(i)\val)
        
    EndSelect
    
    If TormozFlag      
      Break
    EndIf 
    
  Next
  
  ;silence when stop
  Write(%10011111)
  Write(%10111111)
  Write(%11011111)
  Write(%11111111)
  
  Write(%110011111)
  Write(%110111111)
  Write(%111011111)
  Write(%111111111)
  
EndProcedure

Procedure ParsePlay(*FileMem)
  
  memsize = MemorySize(*FileMem)

  ;get version of vgm
  ver$ = ""
  tmp = PeekA(*FileMem + 11)
  ver$ = Str(GetBits(tmp, 4, 7))
  ver$ + Str(GetBits(tmp, 0, 3))
  tmp = PeekA(*FileMem + 10)
  ver$ + Str(GetBits(tmp, 4, 7))
  ver$ + Str(GetBits(tmp, 0, 3))
  tmp = PeekA(*FileMem + 9)
  ver$ + Str(GetBits(tmp, 4, 7))
  ver$ + Str(GetBits(tmp, 0, 3))
  tmp = PeekA(*FileMem + 8)
  ver$ + Str(GetBits(tmp, 4, 7))
  ver$ + Str(GetBits(tmp, 0, 3))

  If Val(ver$) < 151
    ot = *FileMem + 64      ; 64 - it is vgm header. no need it yet
  Else
    ot = *FileMem + 256
  EndIf  
  do = *FileMem + memsize

  ; create array with size as filesize. array will get less size, than file, but it is ok
  Dim VGMARR(memsize)

  Number.a = 0
  PSGvalue.a
  Arrayind = 0  
  
  For i = ot To do
    
    Number = PeekA(i)
    
    Select Number      
        
      Case $67  ;  0x67 0x66 tt ss ss ss ss (data)
        ; it is big wav data block        
        ; get size of wav data block
        WavDataSize = PeekI(i + 3)
        ; get adress of wav data block
        WavAddres = i + 7
        ; jump to end of wav data block
        i + 6 + WavDataSize 
        
      Case $52 ; $52 - register +0
        i+2
        
      Case $53 ; $53 - register +256
        i+2 
        
      Case $61 ; $61 - can range from 0 to 65535 (approx 1.49 seconds)
        VGMARR(Arrayind)\type = 3
        VGMARR(Arrayind)\pause = PeekU(i + 1)
        If flagpausehunt
          VGMARR(numforsizecount)\summofpauses + VGMARR(Arrayind)\pause
          flagpausehunt = 0
        EndIf
        Arrayind + 1
        i+2
        
      Case $70 To $7F ; wait n+1 samples, n can range from 0 to 15.
        VGMARR(Arrayind)\type = 3
        VGMARR(Arrayind)\pause = ((Number - $70) + 1)
        If flagpausehunt
          VGMARR(numforsizecount)\summofpauses + VGMARR(Arrayind)\pause
          flagpausehunt = 0
        EndIf
        Arrayind + 1
        
      Case $E0 ; 0xE0	dddddddd	seek to offset dddddddd (Intel byte order) in PCM data bank
        ;jump far
        i + 4
        
      Case $80 To $8F
        flagpausehunt = 1        
        If Number > $80
          VGMARR(Arrayind)\type = 3
          VGMARR(Arrayind)\pause = (Number - $80)
          VGMARR(numforsizecount)\summofpauses + VGMARR(Arrayind)\pause
          Arrayind + 1
        EndIf
        
      Case $4F ; 0x4F	dd	Game Gear PSG stereo, write dd to port 0x06 ; dune with samples
        i + 1
        PSGvalue = PeekA(i)
        VGMARR(Arrayind)\type = 7
        VGMARR(Arrayind)\val = PSGvalue
        Arrayind + 1        
        i + 1
        
      Case $3F ; 0x4F	dd	Game Gear PSG stereo, write dd to port 0x06 ; dune with samples
        i + 1
        PSGvalue = PeekA(i)
        VGMARR(Arrayind)\type = 7
        VGMARR(Arrayind)\val = PSGvalue + 256
        Arrayind + 1        
        i + 1
        
      ;MAIN COMMAND :))
      Case $50 ; 0x50	dd	PSG (SN76489/SN76496) write value dd ; dune with samples
        i + 1
        PSGvalue = PeekA(i)
        VGMARR(Arrayind)\type = 5
        VGMARR(Arrayind)\val = PSGvalue
        Arrayind + 1
        
      Case $30 ; 0x50	dd	PSG (SN76489/SN76496) write value dd ; dune with samples
        i + 1
        PSGvalue = PeekA(i)
        VGMARR(Arrayind)\type = 5
        VGMARR(Arrayind)\val = PSGvalue + 256
        Arrayind + 1  
        
        
      Case $62 ; wait 735 samples (60th of a second), a shortcut for 0x61 0xdf 0x02 ; Lego Tune
        VGMARR(Arrayind)\type = 3
        VGMARR(Arrayind)\pause = 735
        If flagpausehunt
          VGMARR(numforsizecount)\summofpauses + VGMARR(Arrayind)\pause
          flagpausehunt = 0
        EndIf
        Arrayind + 1
        
      Case $63 ; wait 882 samples (50th of a second), a shortcut For 0x61 0x72 0x03
        VGMARR(Arrayind)\type = 3
        VGMARR(Arrayind)\pause = 882
        If flagpausehunt
          VGMARR(numforsizecount)\summofpauses + VGMARR(Arrayind)\pause
          flagpausehunt = 0
        EndIf
        Arrayind + 1
        
      Case $66 ; end of sound
        Debug "end"        
        Break 
        
      Default 
        ;Debug "unknown command " + Hex(Number)
        
        
    EndSelect
    
    If TormozFlag
      Break
    EndIf

  Next
  
  If TormozFlag = 0
    Play(0)
  EndIf
  
EndProcedure

#ENABLE_GZIP = 16
; #ZLIB_VERSION = "1.2.8"

#Z_NULL = 0
#Z_OK = 0
#Z_STREAM_END = 1
#Z_FINISH = 4
#Z_BLOCK         =  5

Structure Z_STREAM
  *next_in.Byte
  avail_in.l
  total_in.l
  *next_out.Byte
  avail_out.l
  total_out.l
  *msg.Byte
  *state
  zalloc.l     
  zfree.l  
  opaque.l
  
  CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
    PB_Alignment1.b[4]
  CompilerEndIf
  
  data_type.i
  adler.l
  reserved.l
  
  CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
    PB_Alignment2.b[8]
  CompilerEndIf  
EndStructure

ImportC "zlib.lib"
  zlibVersion()
  inflateInit2_(*strm, windowBits.i, Version.s, strm_size)
  inflate(*strm, flush.i)
  inflateEnd(*strm)
  deflateInit2_(*strm, level.i, method.i, windowBits.i, memlevel.i, strategy.i, Version.s, strm_size)  
  deflateBound(*strm, sourceLen.l)
  deflate(*strm, flush.i)
  deflateEnd(*strm)
EndImport : Global ZLIB_VERSION$ = PeekS(zlibVersion(), -1, #PB_Ascii)

Procedure InflatePayload(*TmpMem, windowBits.i, size.i)
  Debug "запустилось"
  LengthToRead = MemorySize(*TmpMem)
  LengthToWrite = size;FileSize("1test.dds")
  *MemoryID = AllocateMemory(LengthToWrite)
  strm.Z_STREAM
  strm\next_in = *TmpMem
  strm\avail_in = LengthToRead
  strm\next_out = *MemoryID
  strm\avail_out = LengthToWrite
  strm\zalloc = #Z_NULL
  strm\zfree = #Z_NULL
  strm\opaque = #Z_NULL
  inflateInit2_(@strm, windowBits, ZLIB_VERSION$, SizeOf(Z_STREAM))
  inflate(@strm, #Z_FINISH)
  inflateEnd(@strm)
  ProcedureReturn *MemoryID
EndProcedure




If OpenWindow(#Window, 100, 200, 195, 260, "PureBasic Window", #PB_Window_SystemMenu | #PB_Window_MinimizeGadget | #PB_Window_MaximizeGadget)
  
  StringGadget(#PathString, 10, 20, 120, 20, "", #PB_String_ReadOnly)
  ButtonGadget(#OpenButton, 130, 20, 50, 20, "open")
  
  TextGadget(#Text, 10, 40, 170, 120, "WARNING! VGZ must be unpacked by manualy into VGM (7z can do this. i cant plug zlib yet). and see what chips was used by this VGM. it plays only one SN76489 (not dual). YM2612 is ignored. any VGM with other chips can crash programm.")
  
  FrameGadget(#Fr01, 1, 158, 93, 97, "1 chip")
  FrameGadget(#Fr02, 95, 158, 93, 97, "2 chip")
  
  
  CheckBoxGadget(#Ch1L, 5, 170, 70, 20, "L   1Ch   R")
  CheckBoxGadget(#Ch2L, 5, 190, 70, 20, "L   2Ch   R")
  CheckBoxGadget(#Ch3L, 5, 210, 70, 20, "L   3Ch   R")
  CheckBoxGadget(#Ch4L, 5, 230, 70, 20, "L   4Ch   R")
  
  CheckBoxGadget(#Ch1R, 75, 170, 16, 20, "")
  CheckBoxGadget(#Ch2R, 75, 190, 16, 20, "")
  CheckBoxGadget(#Ch3R, 75, 210, 16, 20, "")
  CheckBoxGadget(#Ch4R, 75, 230, 16, 20, "")
  
  CheckBoxGadget(#Ch1L2, 100, 170, 70, 20, "L   1Ch   R")
  CheckBoxGadget(#Ch2L2, 100, 190, 70, 20, "L   2Ch   R")
  CheckBoxGadget(#Ch3L2, 100, 210, 70, 20, "L   3Ch   R")
  CheckBoxGadget(#Ch4L2, 100, 230, 70, 20, "L   4Ch   R")
  
  CheckBoxGadget(#Ch1R2, 170, 170, 16, 20, "")
  CheckBoxGadget(#Ch2R2, 170, 190, 16, 20, "")
  CheckBoxGadget(#Ch3R2, 170, 210, 16, 20, "")
  CheckBoxGadget(#Ch4R2, 170, 230, 16, 20, "")

  
  Repeat
    
    Event = WaitWindowEvent()
    
    Select Event

      Case #PB_Event_Gadget
        Select EventGadget()
          ;- Event  
          Case #OpenButton
            If File$
              StandardFile$ = GetPathPart(File$)
            Else
              StandardFile$ = "C:\" ;GetPathPart(ProgramFilename());         ; initial path + file
            EndIf
            Pattern$ = "VGM files (*.vgm)|*.vgm;*.vgz;";*.vgz|"   ; set first pattern  (index = 0)
            Pattern = 0    ; use the second of the five possible patterns as standard

            ; Now we open a filerequester, you can change the pattern and will get the index after closing
            File$ = OpenFileRequester("Please choose file to load", StandardFile$, Pattern$, Pattern)
            If File$
              For i = #Ch1R To #Ch4L2
                SetGadgetState(i, 1)
              Next
              GGStereoWrite(255)
              GGStereoWrite(255 + 256)
              
              TormozFlag = 1
              If IsThread(PlThr)
                WaitThread(PlThr)
              EndIf
              SetGadgetText(#PathString, File$)
              
              If ReadFile(#File, File$)
                
                If *MemoryID
                  FreeMemory(*MemoryID)
                  *MemoryID = 0
                EndIf
                
                length = Lof(#File)
                
                If ReadByte(#File) = $56 And ReadByte(#File) = $67 And ReadByte(#File) = $6D
                  ;unpacked VGM 
                  Debug "unpacked"
                  *MemoryID = AllocateMemory(length)         ; allocate the needed memory
                  If *MemoryID
                    ReadData(#File, *MemoryID, length)   ; read all data into the memory block
                  EndIf
                Else                  
                  Debug "packed"
                  ;get size unpacked
                  FileSeek(#File, length - 4)
                  unpsz = ReadLong(#File)
                  
                  If *TmpMem
                    FreeMemory(*TmpMem)
                    *TmpMem = 0
                  EndIf
                  
                  *TmpMem = AllocateMemory(length)         ; allocate the needed memory
                  If *TmpMem
                    FileSeek(#File, 0)
                    ReadData(#File, *TmpMem, length)   ; read all data into the memory block
                    
                    *MemoryID = InflatePayload(*TmpMem, #ENABLE_GZIP, unpsz) ;unpack  
                    
                  EndIf
                  
                EndIf                  

                CloseFile(#File)
                
                TormozFlag = 0
                
                If *MemoryID
                  PlThr = CreateThread(@ParsePlay(), *MemoryID)
                Else
                  MessageRequester("error", "cant read file")
                EndIf                
                
              EndIf
              
            EndIf
            
          Case #Ch1R To #Ch4L
            forstereo = 0
            For i = #Ch1R To #Ch4L
              value = GetGadgetState(i)
              If value
                SetBit(forstereo, NumToBit(i-#Ch1R))
              Else
                ClearBit(forstereo, NumToBit(i-#Ch1R))
              EndIf
            Next
            GGStereoWrite(forstereo)
            
          Case #Ch1R2 To #Ch4L2
            forstereo = 0
            For i = #Ch1R2 To #Ch4L2
              value = GetGadgetState(i)
              If value
                SetBit(forstereo, NumToBit(i-#Ch1R2))
              Else
                ClearBit(forstereo, NumToBit(i-#Ch1R2))
              EndIf
            Next
            GGStereoWrite(forstereo + 256)
            
        EndSelect
            
            

      Case #PB_Event_CloseWindow
         Quit = 1
         
    EndSelect

  Until Quit = 1
  
EndIf

End 

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 692
; FirstLine = 685
; Folding = -----
; EnableUnicode
; EnableThread
; EnableXP
; Executable = на форум\testplay.exe